#line 1 "E:/temporary_work/103_breadboard/_for_libstock/fft_sin_windowed/fft_sin_window.c"









const unsigned int sinTable[ 120 ] =
{500, 526, 552, 578, 604, 629, 655, 679, 703, 727, 750, 772, 794, 815, 835, 854, 872, 889, 905, 919, 933, 946, 957, 967, 976, 983, 989, 994, 997, 999, 1000, 999, 997, 994, 989, 983, 976, 967, 957, 946, 933, 919, 905, 889, 872, 854, 835, 815, 794, 772, 750, 727, 703, 679, 655, 629, 604, 578, 552, 526, 500, 474, 448, 422, 396, 371, 345, 321, 297, 273, 250, 228, 206, 185, 165, 146, 128, 111, 95, 81, 67, 54, 43, 33, 24, 17, 11, 6, 3, 1, 0, 1, 3, 6, 11, 17, 24, 33, 43, 54, 67, 81, 95, 111, 128, 146, 165, 185, 206, 228, 250, 273, 297, 321, 345, 371, 396, 422, 448, 474};

unsigned int num=0;
char data_send_time=0;
float realNumbers_float[ 1024 ];
float imaginaryNumbers_float[ 1024 ];

extern int FFT( int dir,int m,float *x,float *y);

 void adc_inter() iv IVT_INT_ADC1_2
 {
 ADC1_SRbits.EOC=0;

 if(data_send_time==0)
 {
  GPIOC_ODR.B13 =0;
 if(num< 1024 )
 {
 realNumbers_float[num]=ADC1_DRbits.DATA;
 imaginaryNumbers_float[num]=0;
 num++;
 }
 else
 {
 num=0;
 data_send_time=1;
 }
  GPIOC_ODR.B13 =1;
 }
 }

void timer_3_init()
 {
 RCC_APB1ENR.TIM3EN = 1;
 TIM3_CR1.CEN = 0;
 TIM3_PSC = 7030;
 TIM3_ARR = 9;
 TIM3_CR2bits.MMS=2;
 TIM3_CR1.CEN = 1;
 }

 void ADC_init(void)
 {
 GPIO_Analog_Input(&GPIOA_BASE, _GPIO_PINMASK_0);

 RCC_APB2ENRbits.ADC1EN=1;
 ADC1_CR2bits.EXTSEL=4;
 ADC1_CR2bits.EXTTRIG=1;
 ADC1_SMPR2bits.SMP0=1;
 ADC1_CR1bits.EOCIE=1;
 ADC1_CR2bits.ADON=1;
 NVIC_IntEnable(IVT_INT_ADC1_2);
 }




 void init_TIM4()
{
 RCC_APB1ENRbits.TIM4EN=1;
 TIM4_CCERbits.CC3E=1;
 TIM4_CCMR2_Outputbits.OC3M=6;
 TIM4_CCMR2_Outputbits.OC3PE=1;
 TIM4_DIERbits.CC3DE=1;
 TIM4_CR1bits.CEN=1;
 TIM4_CR1bits.ARPE=1;
 TIM4_PSC=8;
 TIM4_ARR=999;
 TIM4_CCR3=500;
}

void init_DMA()
{
 RCC_AHBENRbits.DMA1EN=1;
 DMA1_CPAR5=&TIM4_CCR3;
 DMA1_CMAR5=&sinTable;
 DMA1_CNDTR5= 120 ;
 DMA1_CCR5=0x000005B1;
}

void init_GPIO()
{
 RCC_APB2ENRbits.IOPBEN=1;
 RCC_APB2ENRbits.AFIOEN=1;
 GPIOB_CRHbits.MODE8=1;
 GPIOB_CRHbits.CNF8=2;
}

void init_PWM_sin()
{
 init_GPIO();
 init_TIM4();
 init_DMA();
}

void init_peripherals(void)
{
 GPIO_Digital_Output(&GPIOC_BASE, _GPIO_PINMASK_13);
 GPIOC_ODR.B13=1;

 ADC_init();
 timer_3_init();

 init_PWM_sin();

 UART1_Init(115200);
}

void adc_buf_send(void)
{
 unsigned int i=0;
 int tempi=0;
 char temp=0;

 for(i=0;i< 1024 /2;i++)
 {
 tempi=realNumbers_float[i];
 temp=tempi>>8;
 UART1_Write(temp);
 temp=tempi&0x00FF;
 UART1_Write(temp);

 }

}

void from_adc_to_milivolts(void)
{
 unsigned int i=0;
 unsigned long temp=0;
 for(i=0;i< 1024 ;i++)
 {
 temp=realNumbers_float[i];
 temp=temp*3335;
 temp=temp/4095;
 realNumbers_float[i]=temp;
 }
}

void module_bufer(void)
{
 int k=0;
 double max=0;

 for(k=0;k< 1024 /2;k++)
 {
 realNumbers_float[k]=sqrt(realNumbers_float[k]*realNumbers_float[k]+imaginaryNumbers_float[k]*imaginaryNumbers_float[k]);
 if(max<realNumbers_float[k])max=realNumbers_float[k];
 }

 for(k=0;k< 1024 /2;k++)
 {
 realNumbers_float[k]=(float)10*log10(realNumbers_float[k]/max);
 if(realNumbers_float[k]<-100)realNumbers_float[k]=-100;
 }
}

float w_hann( float pos)
{
 return (0.5*(1-cos(pos)));
}

float w_hamming( float pos)
{
 return (0.54 - 0.46 * cos(pos));
}

float w_blackman( float pos)
{
 return (0.42 - 0.5 * cos(pos) + 0.08 * cos(2.0*pos));
}

float w_blackman_harris(float pos)
{
 return (0.35875 - 0.48829 * cos(pos) + 0.14128 * cos(2.0*pos)- 0.01168 * cos(3.0*pos));
}

float w_nuttall(float pos)
{
 return (0.355768 - 0.487396 * cos(pos) + 0.144232 * cos(2.0*pos)- 0.012604 * cos(3.0*pos));
}

float flat_top_window(float pos)
{
 return (1.0 - 1.93 * cos(pos) + 1.29 * cos(2.0*pos)- 0.388 * cos(3.0*pos)+0.028 * cos(4.0*pos));
}

float w_blackman_nuttall(float pos)
{
 return (0.3635819 - 0.4891775 * cos(pos) + 0.1365995 * cos(2.0*pos)- 0.0106411 * cos(3.0*pos));
}

void do_window(float* pOut)
{
 unsigned int i=0;

 for (i=0; i< 1024 ; i++)
 {
 pOut[i] *= w_blackman_nuttall((float)(2* 3.1415926 *i)/( 1024 -1));
 }
}

void main()
{
 init_peripherals();

 while(1)
 {
 if(data_send_time==1)
 {
 from_adc_to_milivolts();
 do_window(realNumbers_float);
 FFT(1,10,realNumbers_float,imaginaryNumbers_float);
 module_bufer();
 adc_buf_send();
 data_send_time=0;
 }
 }
}
